import sys
import pygame
from win32api import MessageBox
from CD import *

pygame.init()

def InitJoysticks():
    if pygame.joystick.get_count() == 0:
        MessageBox(0, 'No switch found, use the space bar')
    else:
        js = pygame.joystick.Joystick(0)
        js.init()

def exit():
    cd.Stop()
    sys.exit()

screen = pygame.display.set_mode((320, 240))
pygame.display.set_caption("TouchCD CD Player")
icon = pygame.image.load("TouchCD.bmp")
pygame.display.set_icon(icon)

#Font = pygame.font.Font(None, 26)
#def showtext(win, pos, text, color, bgcolor):
#    textimg = Font.render(text, 1, color, bgcolor)
#    win.blit(textimg, pos)
#    return pos[0] + textimg.get_width() + 5, pos[1]

#showtext(screen, (10, 30), 'Track '+ str(track) + ' of ' + str(tracks), (255, 255, 255), (0,0,0))
if pygame.cdrom.get_count() == 0:
    MessageBox(0, 'No CD players found')
    sys.exit()
cd = CD(0)

InitJoysticks()

tick_time = 500
preview_down_time = 2000

if len(sys.argv) > 1 and sys.argv[1] == '--continuous':
    normal_playmode = CD_PLAYMODE_CONTINUOUS
else:
    normal_playmode = CD_PLAYMODE_NEXT

TICKCD = pygame.USEREVENT
pygame.time.set_timer(TICKCD, tick_time)
timedown = -1

while 1:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            exit()

        if event.type == TICKCD:
#            showtext(screen, (10, 30), 'Track '+ str(track) + ' of ' + str(tracks), (255, 255, 255), (0,0,0))
             cd.ExecutePlayMode()

        if event.type == pygame.KEYDOWN:
            if event.dict['key'] == pygame.K_ESCAPE:
               exit()

        if event.type == pygame.JOYBUTTONDOWN \
                or (event.type == pygame.KEYDOWN and event.dict['key'] == pygame.K_SPACE):
            timedown = pygame.time.get_ticks()

        if event.type == pygame.JOYBUTTONUP \
                or (event.type == pygame.KEYUP and event.dict['key'] == pygame.K_SPACE):
            if cd.IsPreviewing():
                cd.SetPlayMode(CD_PLAYMODE_AGAIN)
            elif pygame.time.get_ticks() - timedown >= preview_down_time:
                cd.SetPlayMode(CD_PLAYMODE_PREVIEW)
            else:
                if cd.IsPlaying():
                    cd.SetPlayMode(CD_PLAYMODE_STOP)
                else:
                    cd.SetPlayMode(normal_playmode)

        if event.type == pygame.KEYUP and event.dict['key'] == pygame.K_c:
            if normal_playmode == CD_PLAYMODE_NEXT:
                normal_playmode = CD_PLAYMODE_CONTINUOUS
            else:
                normal_playmode = CD_PLAYMODE_NEXT